package com.plannaplan.repositories;

import java.util.Optional;

import com.plannaplan.entities.Lecturer;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

/**
 *  LecturerRepository.find:
 *      Return list of:
 *      SELECT * FROM Lecturer WHERE title = i AND name = j AND surname = k.
 * 
 *      Where i, j, k, ?1, ?2, ?3 are equale to variables. 
 */
@Repository
public interface LecturerRepository extends JpaRepository<Lecturer, Long> {
    @Query("FROM Lecturer WHERE title = ?1 AND name = ?2 AND surname = ?3")
    Optional<Lecturer> find(@Param("title") String title, @Param("name") String name, @Param("surname") String surname);
}